package eaadapter.ea2ecore.postprocessings.util;

import java.io.File;
import java.io.FileFilter;
import java.io.FilenameFilter;

public class Utils {
	
	public static File findFileByName(File root, final String name) {
		File file = null;
		if (root.exists() && root.isDirectory()) {
			File[] files = root.listFiles(new FilenameFilter() {

				@Override
				public boolean accept(File arg0, String arg1) {
					return name.equals(arg1);
				}
			});
			if (files.length > 0) {
				file = files[0];
			}

			if (file == null) {
				files = root.listFiles(new FileFilter() {
					@Override
					public boolean accept(File arg0) {
						return arg0.isDirectory();
					}
				});
				if (files.length > 0) {
					for (File nRoot : files) {
						file = findFileByName(nRoot, name);
						if (file != null) {
							break;
						}
					}
				}
			}
		}
		
		return file;
	}

}
