package eaadapter.emf.codegen.ecore.templates.model;

import org.eclipse.emf.codegen.ecore.genmodel.*;
import org.eclipse.emf.ecore.*;
import org.eclipse.emf.common.util.*;
import eaadapter.templates.internal.util.*;
import java.util.*;

public class Switch
{
  protected static String nl;
  public static synchronized Switch create(String lineSeparator)
  {
    nl = lineSeparator;
    Switch result = new Switch();
    nl = null;
    return result;
  }

  public final String NL = nl == null ? (System.getProperties().getProperty("line.separator")) : nl;
  protected final String TEXT_1 = "";
  protected final String TEXT_2 = "/**";
  protected final String TEXT_3 = NL + " * ";
  protected final String TEXT_4 = NL + " * <copyright>" + NL + " * </copyright>" + NL + " *" + NL + " * ";
  protected final String TEXT_5 = "Id";
  protected final String TEXT_6 = NL + " */" + NL + "package ";
  protected final String TEXT_7 = ";" + NL;
  protected final String TEXT_8 = NL + NL + "/**" + NL + " * <!-- begin-user-doc -->" + NL + " * The <b>Switch</b> for the model's inheritance hierarchy." + NL + " * It supports the call {@link #doSwitch(EObject) doSwitch(object)}" + NL + " * to invoke the <code>caseXXX</code> method for each class of the model," + NL + " * starting with the actual class of the object" + NL + " * and proceeding up the inheritance hierarchy" + NL + " * until a non-null result is returned," + NL + " * which is the result of the switch." + NL + " * <!-- end-user-doc -->" + NL + " */" + NL + "public class ";
  protected final String TEXT_9 = "<T> {" + NL + "" + NL + "    private interface Switch<T> {" + NL + "        T doSwitch(";
  protected final String TEXT_10 = " o);" + NL + "    }" + NL + "" + NL + "    public T doSwitch(EObject o) {" + NL + "        Switch<T> swtch = pkgMap.get(o.eClass().getEPackage());" + NL + "        return swtch==null ? null : swtch.doSwitch(o);" + NL + "    }" + NL + "    ";
  protected final String TEXT_11 = NL + "    public T case";
  protected final String TEXT_12 = "(";
  protected final String TEXT_13 = ".";
  protected final String TEXT_14 = " ";
  protected final String TEXT_15 = ") {" + NL + "        return null;" + NL + "    }" + NL + "    ";
  protected final String TEXT_16 = NL + "    private class Switch";
  protected final String TEXT_17 = " extends ";
  protected final String TEXT_18 = ".util.";
  protected final String TEXT_19 = "Switch<T> implements Switch<T> {";
  protected final String TEXT_20 = NL + "        public T case";
  protected final String TEXT_21 = "(";
  protected final String TEXT_22 = ".";
  protected final String TEXT_23 = " o) {" + NL + "        \treturn ";
  protected final String TEXT_24 = ".this.case";
  protected final String TEXT_25 = "(o);" + NL + "        }";
  protected final String TEXT_26 = NL + "    }";
  protected final String TEXT_27 = NL + "    private class PkgMap extends ";
  protected final String TEXT_28 = "<";
  protected final String TEXT_29 = ", Switch<T>> {" + NL + "        private static final long serialVersionUID = 1L;" + NL + "        " + NL + "        public PkgMap() {";
  protected final String TEXT_30 = NL + "            put(";
  protected final String TEXT_31 = ".";
  protected final String TEXT_32 = "Package.eINSTANCE, new Switch";
  protected final String TEXT_33 = "());";
  protected final String TEXT_34 = NL + "        }" + NL + "    }" + NL + "    " + NL + "    private PkgMap pkgMap = new PkgMap();" + NL + "}";

  public String generate(Object argument)
  {
    final StringBuffer stringBuffer = new StringBuffer();
    
/**
 * <copyright>
 * 
 * Copyright (c) Continental AG and others.
 * All rights reserved. This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 
 * which accompanies this distribution, and is
 * available at http://www.eclipse.org/org/documents/epl-v10.php
 * 
 * Contributors: 
 *     Continental AG - Initial API and implementation
 * 
 * </copyright>
 */

    GenPackage genPackage = (GenPackage)argument; GenModel genModel=genPackage.getGenModel();
    stringBuffer.append(TEXT_1);
    stringBuffer.append(TEXT_2);
    {GenBase copyrightHolder = argument instanceof GenBase ? (GenBase)argument : argument instanceof Object[] && ((Object[])argument)[0] instanceof GenBase ? (GenBase)((Object[])argument)[0] : null;
    if (copyrightHolder != null && copyrightHolder.hasCopyright()) {
    stringBuffer.append(TEXT_3);
    stringBuffer.append(copyrightHolder.getCopyright(copyrightHolder.getGenModel().getIndentation(stringBuffer)));
    } else {
    stringBuffer.append(TEXT_4);
    stringBuffer.append("$");
    stringBuffer.append(TEXT_5);
    stringBuffer.append("$");
    }}
    stringBuffer.append(TEXT_6);
    stringBuffer.append(GenModels.getRootGenPackage(genModel).getUtilitiesPackageName());
    stringBuffer.append(TEXT_7);
    genModel.markImportLocation(stringBuffer);
    stringBuffer.append(TEXT_8);
    stringBuffer.append(GenModels.getUtilityClassSimpleName(genModel, "Switch"));
    stringBuffer.append(TEXT_9);
    stringBuffer.append(genModel.getImportedName("org.eclipse.emf.ecore.EObject"));
    stringBuffer.append(TEXT_10);
    TreeIterator<EObject> iterator = genModel.eAllContents();
    while (iterator.hasNext()) {
    EObject currentObject = iterator.next();
    if (currentObject instanceof GenClass) {
    EClass clsObj = ((GenClass)currentObject).getEcoreClass();
    String qualifiedPckName = EClasses.getQualifiedPackageName(clsObj);
    stringBuffer.append(TEXT_11);
    stringBuffer.append(clsObj.getName());
    stringBuffer.append(TEXT_12);
    stringBuffer.append(qualifiedPckName);
    stringBuffer.append(TEXT_13);
    stringBuffer.append(clsObj.getName());
    stringBuffer.append(TEXT_14);
    stringBuffer.append(EClasses.getVarName(clsObj));
    stringBuffer.append(TEXT_15);
    }
    }
    iterator = genModel.eAllContents();
    List<GenPackage> pckList = new ArrayList<GenPackage>();
    while (iterator.hasNext()) {
    EObject currentObject = iterator.next();
    if (currentObject instanceof GenPackage) {
    GenPackage genPck = (GenPackage)currentObject;
    if (genPck.getGenClasses().size() <= 0) {
    continue;
    }
    pckList.add(genPck);
    stringBuffer.append(TEXT_16);
    stringBuffer.append(pckList.size());
    stringBuffer.append(TEXT_17);
    stringBuffer.append(genPck.getQualifiedPackageName());
    stringBuffer.append(TEXT_18);
    stringBuffer.append(Character.toUpperCase(genPck.getPackageName().charAt(0)) + genPck.getPackageName().substring(1));
    stringBuffer.append(TEXT_19);
    EList<GenClass> genClasses = genPck.getGenClasses();
    for (GenClass gCls : genClasses) {
    EClass clsObj = ((GenClass)gCls).getEcoreClass();
    stringBuffer.append(TEXT_20);
    stringBuffer.append(clsObj.getName());
    stringBuffer.append(TEXT_21);
    stringBuffer.append(genPck.getQualifiedPackageName());
    stringBuffer.append(TEXT_22);
    stringBuffer.append(clsObj.getName());
    stringBuffer.append(TEXT_23);
    stringBuffer.append(GenModels.getUtilityClassSimpleName(genModel, "Switch"));
    stringBuffer.append(TEXT_24);
    stringBuffer.append(clsObj.getName());
    stringBuffer.append(TEXT_25);
    }
    stringBuffer.append(TEXT_26);
    }
    }
    stringBuffer.append(TEXT_27);
    stringBuffer.append(genModel.getImportedName("java.util.HashMap"));
    stringBuffer.append(TEXT_28);
    stringBuffer.append(genModel.getImportedName("org.eclipse.emf.ecore.EPackage"));
    stringBuffer.append(TEXT_29);
    for (int i = 0; i < pckList.size(); ++i) {
    GenPackage gPck = pckList.get(i);
    stringBuffer.append(TEXT_30);
    stringBuffer.append(gPck.getQualifiedPackageName());
    stringBuffer.append(TEXT_31);
    stringBuffer.append(Character.toUpperCase(gPck.getPackageName().charAt(0)) + gPck.getPackageName().substring(1));
    stringBuffer.append(TEXT_32);
    stringBuffer.append(1 + i);
    stringBuffer.append(TEXT_33);
    }
    stringBuffer.append(TEXT_34);
    genModel.emitSortedImports();
    return stringBuffer.toString();
  }
}
