package eaadapter.ea2ecore.postprocessings;

import java.util.Iterator;

import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import eaadapter.ea2ecore.PostProcessingTemplate;

public class DeleteExampleModelPackage extends PostProcessingTemplate {
	
	private void removeExampleModelPackage(EPackage parent) {
		Iterator<EObject> iter = parent.eAllContents();
		while (iter.hasNext()) {
			EObject element = (EObject) iter.next();
			if (element instanceof EPackage) {
				
				if ("model".equals(((EPackage) element).getName())) {
					EList<EPackage> ePackageList = ((EPackage) element).getESubpackages();
					for(EPackage ePackage : ePackageList){
						if(ePackage.getName().equals("examplemodel")){
							ePackageList.remove(ePackage);
							logger.info("Removed 'examplemodel' Package ");
							return;
						}
					}					
				}
				
				
			}
		}
	}


	@Override
	public void execute() {
		removeExampleModelPackage(model);
	}
}
