package eaadapter.emf.codegen.ecore.templates.model;

import java.util.*;
import org.eclipse.emf.codegen.ecore.genmodel.*;
import eaadapter.templates.internal.util.GenModels;
import eaadapter.templates.source.*;
import eaadapter.templates.internal.util.GenPackages;

public class PluginXML
{
  protected static String nl;
  public static synchronized PluginXML create(String lineSeparator)
  {
    nl = lineSeparator;
    PluginXML result = new PluginXML();
    nl = null;
    return result;
  }

  public final String NL = nl == null ? (System.getProperties().getProperty("line.separator")) : nl;
  protected final String TEXT_1 = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>" + NL + "<?eclipse version=\"3.0\"?>" + NL;
  protected final String TEXT_2 = NL;
  protected final String TEXT_3 = "<!--";
  protected final String TEXT_4 = NL + " ";
  protected final String TEXT_5 = NL + " <copyright>" + NL + " </copyright>" + NL;
  protected final String TEXT_6 = NL + " ";
  protected final String TEXT_7 = "Id";
  protected final String TEXT_8 = NL + "-->" + NL;
  protected final String TEXT_9 = NL + "<plugin>";
  protected final String TEXT_10 = NL + "<plugin" + NL + "      name=\"%pluginName\"" + NL + "      id=\"";
  protected final String TEXT_11 = "\"" + NL + "      version=\"1.0.0\"";
  protected final String TEXT_12 = NL + "      provider-name=\"%providerName\"" + NL + "      class=\"";
  protected final String TEXT_13 = "$Implementation\">";
  protected final String TEXT_14 = NL + "      provider-name=\"%providerName\">";
  protected final String TEXT_15 = NL + NL + "   <requires>";
  protected final String TEXT_16 = NL + "      <import plugin=\"";
  protected final String TEXT_17 = "\"";
  protected final String TEXT_18 = " export=\"true\"";
  protected final String TEXT_19 = "/>";
  protected final String TEXT_20 = NL + "   </requires>" + NL + "" + NL + "   <runtime>";
  protected final String TEXT_21 = NL + "      <library name=\"";
  protected final String TEXT_22 = ".jar\">";
  protected final String TEXT_23 = NL + "      <library name=\".\">";
  protected final String TEXT_24 = NL + "         <export name=\"*\"/>" + NL + "      </library>" + NL + "   </runtime>";
  protected final String TEXT_25 = NL + "     ";
  protected final String TEXT_26 = NL + "     <extension point=\"org.eclipse.emf.ecore.generated_package\">" + NL + "      <package" + NL + "            uri=\"";
  protected final String TEXT_27 = "\"";
  protected final String TEXT_28 = NL + "            class=\"";
  protected final String TEXT_29 = ".";
  protected final String TEXT_30 = "Package\"" + NL + "            genModel=\"";
  protected final String TEXT_31 = "\"/>";
  protected final String TEXT_32 = NL + "            class=\"";
  protected final String TEXT_33 = ".";
  protected final String TEXT_34 = "Package\"/>";
  protected final String TEXT_35 = NL + "     </extension>";
  protected final String TEXT_36 = NL + "     ";
  protected final String TEXT_37 = NL + "     <extension" + NL + "         point=\"org.eclipse.sphinx.emf.metaModelDescriptors\">" + NL + "       <descriptor" + NL + "            id=\"";
  protected final String TEXT_38 = "\"" + NL + "            class=\"";
  protected final String TEXT_39 = ".";
  protected final String TEXT_40 = "ReleaseDescriptor\">" + NL + "       </descriptor>" + NL + "     </extension>     " + NL + "     ";
  protected final String TEXT_41 = NL + "   <extension point=\"org.eclipse.emf.ecore.generated_package\">" + NL + "      <package" + NL + "            uri=\"";
  protected final String TEXT_42 = "\"";
  protected final String TEXT_43 = NL + "            class=\"";
  protected final String TEXT_44 = "\"" + NL + "            genModel=\"";
  protected final String TEXT_45 = "\"/>";
  protected final String TEXT_46 = NL + "            class=\"";
  protected final String TEXT_47 = "\"/>";
  protected final String TEXT_48 = NL + "   </extension>";
  protected final String TEXT_49 = NL;
  protected final String TEXT_50 = NL + "   <extension point=\"org.eclipse.emf.ecore.content_parser\">" + NL + "      <parser" + NL + "            contentTypeIdentifier=\"";
  protected final String TEXT_51 = "\"" + NL + "            class=\"";
  protected final String TEXT_52 = "\"/>" + NL + "   </extension>";
  protected final String TEXT_53 = NL + NL + "  " + NL + "   <extension point=\"org.eclipse.core.contenttype.contentTypes\">" + NL + "      <content-type" + NL + "            base-type=\"";
  protected final String TEXT_54 = "\"" + NL + "            file-extensions=\"";
  protected final String TEXT_55 = "\"" + NL + "            id=\"";
  protected final String TEXT_56 = "\"" + NL + "            name=\"%_UI_";
  protected final String TEXT_57 = "_content_type\"" + NL + "            priority=\"normal\">" + NL + "         <describer class=\"org.eclipse.emf.ecore.xmi.impl.RootXMLContentHandlerImpl$Describer\">";
  protected final String TEXT_58 = NL + "\t\t<parameter name=\"namespacePattern\" value=\"";
  protected final String TEXT_59 = "\"/>    " + NL + "\t";
  protected final String TEXT_60 = NL + "            <parameter name=\"kind\" value=\"xmi\"/>";
  protected final String TEXT_61 = NL + "         </describer>" + NL + "      </content-type>" + NL + "   </extension>" + NL + "" + NL + "   ";
  protected final String TEXT_62 = NL + NL + "   <extension point=\"org.eclipse.emf.ecore.extension_parser\">" + NL + "      <parser" + NL + "            type=\"";
  protected final String TEXT_63 = "\"" + NL + "            class=\"";
  protected final String TEXT_64 = "\"/>" + NL + "   </extension>";
  protected final String TEXT_65 = "  ";
  protected final String TEXT_66 = NL + "     " + NL + "  <extension" + NL + "    point=\"org.eclipse.sphinx.emf.validation.registration\">" + NL + "    <model" + NL + "      NsURI=\"";
  protected final String TEXT_67 = "\"" + NL + "      class=\"";
  protected final String TEXT_68 = "\"" + NL + "      filter=\"";
  protected final String TEXT_69 = "\"" + NL + "      Name=\"";
  protected final String TEXT_70 = "\"" + NL + "      id=\"";
  protected final String TEXT_71 = "\">" + NL + "    </model>" + NL + "   </extension>" + NL + "" + NL + "</plugin>";
  protected final String TEXT_72 = NL;

  public String generate(Object argument)
  {
    final StringBuffer stringBuffer = new StringBuffer();
    
/**
 * <copyright>
 *
 * Copyright (c) 2002-2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *   IBM - Initial API and implementation
 *
 * </copyright>
 */

    GenModel genModel = (GenModel)argument; /* Trick to import java.util.* without warnings */Iterator.class.getName();
    GenPackage rootGenPackage = GenModels.getRootGenPackage(genModel);
    stringBuffer.append(TEXT_1);
    stringBuffer.append(TEXT_2);
    stringBuffer.append(TEXT_3);
    {GenBase copyrightHolder = argument instanceof GenBase ? (GenBase)argument : argument instanceof Object[] && ((Object[])argument)[0] instanceof GenBase ? (GenBase)((Object[])argument)[0] : null;
    if (copyrightHolder != null && copyrightHolder.hasCopyright()) {
    stringBuffer.append(TEXT_4);
    stringBuffer.append(copyrightHolder.getCopyright(copyrightHolder.getGenModel().getIndentation(stringBuffer)));
    } else {
    stringBuffer.append(TEXT_5);
    stringBuffer.append(TEXT_6);
    stringBuffer.append("$");
    stringBuffer.append(TEXT_7);
    stringBuffer.append("$");
    }}
    stringBuffer.append(TEXT_8);
    if (genModel.isBundleManifest()) {
    stringBuffer.append(TEXT_9);
    } else {
    stringBuffer.append(TEXT_10);
    stringBuffer.append(genModel.getModelPluginID());
    stringBuffer.append(TEXT_11);
    if (genModel.hasModelPluginClass()) { 
    stringBuffer.append(TEXT_12);
    stringBuffer.append(genModel.getQualifiedModelPluginClassName());
    stringBuffer.append(TEXT_13);
    } else {
    stringBuffer.append(TEXT_14);
    }
    stringBuffer.append(TEXT_15);
    for (String pluginID : genModel.getModelRequiredPlugins()) {
    stringBuffer.append(TEXT_16);
    stringBuffer.append(pluginID);
    stringBuffer.append(TEXT_17);
    if (!pluginID.startsWith("org.eclipse.core.runtime")) {
    stringBuffer.append(TEXT_18);
    }
    stringBuffer.append(TEXT_19);
    }
    stringBuffer.append(TEXT_20);
    if (genModel.isRuntimeJar()) {
    stringBuffer.append(TEXT_21);
    stringBuffer.append(genModel.getModelPluginID());
    stringBuffer.append(TEXT_22);
    } else {
    stringBuffer.append(TEXT_23);
    }
    stringBuffer.append(TEXT_24);
    }
    
List<GenPackage> genPackagesWithClassifiers = genModel.getAllGenPackagesWithClassifiers();
genPackagesWithClassifiers.add(GenModels.getRootGenPackage(genModel));

    for (GenPackage genPackage : genPackagesWithClassifiers) {
    if((genPackage == GenModels.getRootGenPackage(genModel))) {
    stringBuffer.append(TEXT_25);
    if (GenModels.hasRootUtilitiesGenPackage(genModel)) {
    stringBuffer.append(TEXT_26);
    stringBuffer.append(GenModels.getEastADLReleaseNamespace(genModel));
    stringBuffer.append(TEXT_27);
    if (genModel.hasLocalGenModel()) {
    stringBuffer.append(TEXT_28);
    stringBuffer.append(GenModels.getRootGenPackage(genModel).getUtilitiesPackageName());
    stringBuffer.append(TEXT_29);
    stringBuffer.append(GenModels.getRootGenPackage(genModel).getPrefix());
    stringBuffer.append(TEXT_30);
    stringBuffer.append(genModel.getRelativeGenModelLocation());
    stringBuffer.append(TEXT_31);
    } else {
    stringBuffer.append(TEXT_32);
    stringBuffer.append(GenModels.getRootGenPackage(genModel).getUtilitiesPackageName());
    stringBuffer.append(TEXT_33);
    stringBuffer.append(GenModels.getRootGenPackage(genModel).getPrefix());
    stringBuffer.append(TEXT_34);
    }
    stringBuffer.append(TEXT_35);
    }
    stringBuffer.append(TEXT_36);
    if (GenModels.hasRootUtilitiesGenPackage(genModel)) {
    stringBuffer.append(TEXT_37);
    stringBuffer.append(GenModels.getEastADLMMDescriptorID(genModel));
    stringBuffer.append(TEXT_38);
    stringBuffer.append(rootGenPackage.getUtilitiesPackageName());
    stringBuffer.append(TEXT_39);
    stringBuffer.append(rootGenPackage.getPrefix());
    stringBuffer.append(TEXT_40);
    }
    } else {
    stringBuffer.append(TEXT_41);
    stringBuffer.append(genPackage.getNSURI());
    stringBuffer.append(TEXT_42);
    if (genModel.hasLocalGenModel()) {
    stringBuffer.append(TEXT_43);
    stringBuffer.append(genPackage.getQualifiedPackageInterfaceName());
    stringBuffer.append(TEXT_44);
    stringBuffer.append(genModel.getRelativeGenModelLocation());
    stringBuffer.append(TEXT_45);
    } else {
    stringBuffer.append(TEXT_46);
    stringBuffer.append(genPackage.getQualifiedPackageInterfaceName());
    stringBuffer.append(TEXT_47);
    }
    stringBuffer.append(TEXT_48);
    }
    if (genPackage.isContentType()) {
    stringBuffer.append(TEXT_49);
    if (GenModels.hasRootUtilitiesGenPackage(genModel)) {
    stringBuffer.append(TEXT_50);
    stringBuffer.append(genPackage.getContentTypeIdentifier());
    stringBuffer.append(TEXT_51);
    stringBuffer.append(genPackage.getQualifiedEffectiveResourceFactoryClassName());
    stringBuffer.append(TEXT_52);
    }
    stringBuffer.append(TEXT_53);
    stringBuffer.append(GenPackages.getBaseContentType(genModel, genPackage));
    stringBuffer.append(TEXT_54);
    stringBuffer.append(GenModels.getFileExtension(genModel));
    stringBuffer.append(TEXT_55);
    stringBuffer.append(genPackage.getContentTypeIdentifier());
    stringBuffer.append(TEXT_56);
    stringBuffer.append(genPackage.getPrefix());
    stringBuffer.append(TEXT_57);
    if (genPackage == GenModels.getRootGenPackage(genModel)){
    stringBuffer.append(TEXT_58);
    stringBuffer.append(GenModels.getNamespacePattern(genModel));
    stringBuffer.append(TEXT_59);
    }
    if (genPackage.isXMIResource()) {
    stringBuffer.append(TEXT_60);
    }
    stringBuffer.append(TEXT_61);
    } else if (genPackage.getResource() != GenResourceKind.NONE_LITERAL) {
    stringBuffer.append(TEXT_62);
    stringBuffer.append(genPackage.getFileExtension());
    stringBuffer.append(TEXT_63);
    stringBuffer.append(genPackage.getQualifiedResourceFactoryClassName());
    stringBuffer.append(TEXT_64);
    }
    stringBuffer.append(TEXT_65);
    }
    stringBuffer.append(TEXT_66);
    stringBuffer.append(GenModels.createValidationNSURI(genModel));
    stringBuffer.append(TEXT_67);
    stringBuffer.append(GenModels.createValidationClass(genModel));
    stringBuffer.append(TEXT_68);
    stringBuffer.append(GenModels.createValidationFilter(genModel));
    stringBuffer.append(TEXT_69);
    stringBuffer.append(GenModels.createValidationName(genModel));
    stringBuffer.append(TEXT_70);
    stringBuffer.append(GenModels.createValidationId(genModel));
    stringBuffer.append(TEXT_71);
    stringBuffer.append(TEXT_72);
    return stringBuffer.toString();
  }
}
