reference(nsuri, nsprefix, minmax, reference) ::= <<
$if(reference.derived)$
<!-- The property "$reference.name$/$reference.rolename$" is ignored, because it is derived -->
$elseif(reference.wrapper)$
<xsd:element $cardinalityreduced(reference.cardinality)$ name="$reference.rolename$">
   $annotation(reference.annotation)$
   <xsd:complexType>
      <xsd:choice $cardinality(reference.cardinality)$>
         <xsd:element name="$reference.elementname$">
            <xsd:complexType>
               <xsd:simpleContent>
                  <xsd:extension base="$nsprefix$:REF">
                     <xsd:attribute name="DEST" type="$reference.type$--SUBTYPES-ENUM" use="required"/>
                  </xsd:extension>
               </xsd:simpleContent>
            </xsd:complexType>
         </xsd:element>
      </xsd:choice>
   </xsd:complexType>
</xsd:element>
$else$
<xsd:element $cardinality(reference.cardinality)$ name="$reference.rolename$"> 
   $if(reference.annotation)$
   $annotation(reference.annotation)$
   $endif$
   <xsd:complexType>
      <xsd:simpleContent>
         <xsd:extension base="$nsprefix$:REF">
            <xsd:attribute name="DEST" type="$reference.type$--SUBTYPES-ENUM" use="required"/>
         </xsd:extension>
      </xsd:simpleContent>
   </xsd:complexType>
</xsd:element>
$endif$
>>