abstracttype(nsuri, nsprefix, minmax, abstracttype) ::= <<
<!-- complex type for class $abstracttype.package$::$abstracttype.modelname$ -->
$if(abstracttype.simple)$
<xsd:complexType name="$abstracttype.type; format="noprefix"$" >
   $annotation(abstracttype.annotation)$
   <xsd:simpleContent>
      <xsd:extension base="$abstracttype.basetype$">
         $abstracttype.baseclasswithattributes:{x | <xsd:attributeGroup ref="$nsprefix$:$x.xmlname$"/>}; separator="\n"$
         $if(abstracttype.attributes)$<xsd:attributeGroup ref="$abstracttype.type$"/>$endif$
      </xsd:extension>
   </xsd:simpleContent>
</xsd:complexType>
$elseif(abstracttype.ordered)$
<xsd:complexType abstract="false" mixed="$abstracttype.mixed$" name="$abstracttype.type; format="noprefix"$">
   $annotation(abstracttype.annotation)$
   <xsd:sequence>
      $abstracttype.baseclass:{x | <xsd:group ref="$nsprefix$:$x.xmlname$"/>}; separator="\n"$
      <xsd:group ref="$abstracttype.type$"/>
   </xsd:sequence>
   $abstracttype.baseclasswithattributes:{x | <xsd:attributeGroup ref="$nsprefix$:$x.xmlname$"/>}; separator="\n"$
   $if(abstracttype.attributes)$<xsd:attributeGroup ref="$abstracttype.type$" />$endif$
</xsd:complexType>
$else$
<xsd:complexType abstract="false" mixed="$abstracttype.mixed$" name="$abstracttype.type; format="noprefix"$">
   $annotation(abstracttype.annotation)$
   <xsd:choice maxOccurs="unbounded" minOccurs="0">
      $abstracttype.baseclass:{x | <xsd:group ref="$nsprefix$:$x.xmlname$"/>}; separator="\n"$
      <xsd:group ref="$abstracttype.type$"/>
   </xsd:choice>
   $abstracttype.baseclasswithattributes:{x | <xsd:attributeGroup ref="$nsprefix$:$x.xmlname$"/>}; separator="\n"$
   $if(abstracttype.attributes)$<xsd:attributeGroup ref="$abstracttype.type$" />$endif$
</xsd:complexType>
$endif$
>>